$pcs = "localhost"

foreach ($pc in $pcs) {
    if (Test-Connection $pc -Count 2 -Quiet) {
        $users = (query user /SERVER:$pc) | ForEach-Object {
            $line = $_.Trim()
            if ($line -and $line -match '\s+\d+\s+') {
                $parts = $line -split '\s{2,}'
                [PSCustomObject]@{
                    UserName  = $parts[0]
                    SessionID = $parts[1]
                    State     = if ($parts[2] -eq '„ЁбЄ') { 'Отключено' } else { "Активно" }
                    LogonTime = if ($parts[4] -and $parts[5]) { $parts[4] + " " + $parts[5] } else { $null }
                }
            }
        }

        $pr = Get-WmiObject Win32_Process -ComputerName $pc
        $processes = $pr | ForEach-Object {
            $user = $_.GetOwner().User
            $sessionInfo = $users | Where-Object { $_.UserName -eq $user }
            if ($sessionInfo -and $_.Name -like "1c*") {
                [PSCustomObject]@{
                    Name         = $_.Name
                    PID          = $_.ProcessId
                    UserName     = $user
                    ComputerName = $pc
                    SessionID    = if ($sessionInfo.SessionID -like '*rdp-tcp*') { $sessionInfo.SessionID } else { $null }
                    State        = $sessionInfo.State
                    LogonTime    = $sessionInfo.LogonTime
                }
            }
        }

        if ($processes) {
            $processes | Format-Table -Property Name, PID,  ComputerName, UserName, SessionID, State,  LogonTime -AutoSize
        }
    }
}